--
-- Specialization for Goosneck
--
-- @author  Xentro (http://www.ls-uk.info)
-- @date  16/07/11
--
-- Do not edit without my permission

goosneck = {};

function goosneck.prerequisitesPresent(specializations)
	Vehicle.registerJointType("Goosneck");
	return SpecializationUtil.hasSpecialization(Attachable, specializations);
	--return true;
end;

function goosneck:load(xmlFile)

	print("goosneck.lua have been loaded" );
	
	self.setlockLowboyMax = SpecializationUtil.callSpecializationsFunction("setlockLowboyMax");
	self.setcylinderTub2Max = SpecializationUtil.callSpecializationsFunction("setcylinderTub2Max");
	self.setcylinder2Max = SpecializationUtil.callSpecializationsFunction("setcylinder2Max");
	
    local rotationNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bottomPart#index"));
    if rotationNode1 ~= nil then
        self.bottomPart = {};
        self.bottomPart.node = rotationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bottomPart#minRot"));
        self.bottomPart.minRot = {};
        self.bottomPart.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bottomPart.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bottomPart.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bottomPart#maxRot"));
        self.bottomPart.maxRot = {};
        self.bottomPart.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bottomPart.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bottomPart.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.bottomPart.moveTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.bottomPart#moveTime"), 2)*1000;
        self.bottomPart.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.bottomPart#touchRotLimit"), 10));
    end;
	
	local rotationNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lockLowboy#index"));
    if rotationNode3 ~= nil then
        self.lockLowboy = {};
        self.lockLowboy.node = rotationNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.lockLowboy#minRot"));
        self.lockLowboy.minRot = {};
        self.lockLowboy.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.lockLowboy.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.lockLowboy.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.lockLowboy#maxRot"));
        self.lockLowboy.maxRot = {};
        self.lockLowboy.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.lockLowboy.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.lockLowboy.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.lockLowboy.moveTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.lockLowboy#moveTime"), 2)*1000;
        self.lockLowboy.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.lockLowboy#touchRotLimit"), 10));
    end;
	
	local rotationNode4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.cylinderTub#index"));
    if rotationNode4 ~= nil then
        self.cylinderTub = {};
        self.cylinderTub.node = rotationNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.cylinderTub#minRot"));
        self.cylinderTub.minRot = {};
        self.cylinderTub.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.cylinderTub.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.cylinderTub.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.cylinderTub#maxRot"));
        self.cylinderTub.maxRot = {};
        self.cylinderTub.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.cylinderTub.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.cylinderTub.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.cylinderTub.moveTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.cylinderTub#moveTime"), 2)*1000;
        self.cylinderTub.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.cylinderTub#touchRotLimit"), 10));
    end;
	
	local cylinderNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.cylinder#index"));
    if cylinderNode ~= nil then
        self.cylinder = {};
        self.cylinder.node = cylinderNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.cylinder#minTrans"));
        self.cylinder.minTrans = {};
        self.cylinder.minTrans[1] = Utils.getNoNil(x, 0);
        self.cylinder.minTrans[2] = Utils.getNoNil(y, 0);
        self.cylinder.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.cylinder#maxTrans"));
        self.cylinder.maxTrans = {};
        self.cylinder.maxTrans[1] = Utils.getNoNil(x, 0);
        self.cylinder.maxTrans[2] = Utils.getNoNil(y, 0);
        self.cylinder.maxTrans[3] = Utils.getNoNil(z, 0);

        self.cylinder.moveTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.cylinder#moveTime"), 2)*1000;
        self.cylinder.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.cylinder#touchTransLimit"), 10);
    end;
	
	local rotationNode5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.cylinderTub2#index"));
    if rotationNode5 ~= nil then
        self.cylinderTub2 = {};
        self.cylinderTub2.node = rotationNode5;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.cylinderTub2#minRot"));
        self.cylinderTub2.minRot = {};
        self.cylinderTub2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.cylinderTub2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.cylinderTub2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.cylinderTub2#maxRot"));
        self.cylinderTub2.maxRot = {};
        self.cylinderTub2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.cylinderTub2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.cylinderTub2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.cylinderTub2.moveTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.cylinderTub2#moveTime"), 2)*1000;
        self.cylinderTub2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.cylinderTub2#touchRotLimit"), 10));
    end;
	
	local cylinder2Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.cylinder2#index"));
    if cylinder2Node ~= nil then
        self.cylinder2 = {};
        self.cylinder2.node = cylinder2Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.cylinder2#minTrans"));
        self.cylinder2.minTrans = {};
        self.cylinder2.minTrans[1] = Utils.getNoNil(x, 0);
        self.cylinder2.minTrans[2] = Utils.getNoNil(y, 0);
        self.cylinder2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.cylinder2#maxTrans"));
        self.cylinder2.maxTrans = {};
        self.cylinder2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.cylinder2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.cylinder2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.cylinder2.moveTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.cylinder2#moveTime"), 2)*1000;
        self.cylinder2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.cylinder2#touchTransLimit"), 10);
    end;
	
	local hydraulicSound = getXMLString(xmlFile, "vehicle.hydraulicSound#file");
    if hydraulicSound ~= nil and hydraulicSound ~= "" then
        hydraulicSound = Utils.getFilename(hydraulicSound, self.baseDirectory);
        self.hydraulicSound = createSample("hydraulicSound");
        loadSample(self.hydraulicSound, hydraulicSound, false);
        self.hydraulicSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hydraulicSound#pitchOffset"), 0); 
        self.hydraulicSoundEnabled = false; 
		self.lockLowboySound = false;
		self.goosCylinderSound = false;
    end;
	
	self.reverseLights = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.reverseLights#index"));	
	setVisibility(self.reverseLights, false);
	
	self.helpHudPosX			= 0.833;
    self.helpHudPosY 			= 0.1725;
    self.helpHudWidth			= 0.17;
    self.helpHudHeight 			= 0.55;
    self.helpHudImg = Utils.getFilename("textures/Info_hud_goos.png", self.baseDirectory);
	self.helpHudOverlay = Overlay:new("helpHudOverlay", self.helpHudImg, self.helpHudPosX, self.helpHudPosY, self.helpHudWidth, self.helpHudHeight);
	
	self.greenButton1PosX		= 0.725; 	-- button 1
    self.greenButton1PosY 		= 0.013; 	-- button 1
	self.greenButton2PosX		= 0.725; 	-- button 2
    self.greenButton2PosY 		= 0.041;	-- button 2
	self.greenButton3PosX		= 0.725; 	-- button 3
    self.greenButton3PosY 		= 0.069; 	-- button 3
    self.greenButtonWidth		= 0.018;
    self.greenButtonHeight 		= 0.025;
    self.greenButtonImg = Utils.getFilename("textures/green_button.png", self.baseDirectory);
	self.greenButton1Overlay = Overlay:new("greenButton1Overlay", self.greenButtonImg, self.greenButton1PosX, self.greenButton1PosY, self.greenButtonWidth, self.greenButtonHeight);
	self.greenButton2Overlay = Overlay:new("greenButton2Overlay", self.greenButtonImg, self.greenButton2PosX, self.greenButton2PosY, self.greenButtonWidth, self.greenButtonHeight);
	self.greenButton3Overlay = Overlay:new("greenButton3Overlay", self.greenButtonImg, self.greenButton3PosX, self.greenButton3PosY, self.greenButtonWidth, self.greenButtonHeight);
	
	self.redButton1PosX			= 0.725; 	-- button 1
    self.redButton1PosY 		= 0.013; 	-- button 1
	self.redButton2PosX			= 0.725; 	-- button 2
    self.redButton2PosY 		= 0.041;	-- button 2
	self.redButton3PosX			= 0.725; 	-- button 3
    self.redButton3PosY 		= 0.069; 	-- button 3
    self.redButtonWidth			= 0.018;
    self.redButtonHeight 		= 0.025;
    self.redButtonImg = Utils.getFilename("textures/red_button.png", self.baseDirectory);
	self.redButton1Overlay = Overlay:new("redButton1Overlay", self.redButtonImg, self.redButton1PosX, self.redButton1PosY, self.redButtonWidth, self.redButtonHeight);
	self.redButton2Overlay = Overlay:new("redButton2Overlay", self.redButtonImg, self.redButton2PosX, self.redButton2PosY, self.redButtonWidth, self.redButtonHeight);
	self.redButton3Overlay = Overlay:new("redButton3Overlay", self.redButtonImg, self.redButton3PosX, self.redButton3PosY, self.redButtonWidth, self.redButtonHeight);
	
	self.mesPosX				= 0.613;
    self.mesPosY 				= 0;
    self.mesWidth				= 0.112;
    self.mesHeight 				= 0.1215;
    self.mesImg = Utils.getFilename("textures/text_mes.png", self.baseDirectory);
	self.mesOverlay = Overlay:new("mesOverlay", self.mesImg, self.mesPosX, self.mesPosY, self.mesWidth, self.mesHeight);
	
	self.helpHud 						= false;
	self.loadspace 						= false;
	self.speedViolationMaxTime 			= 2500;
	self.speedViolationTimer 			= self.speedViolationMaxTime;
	self.liftGranted					= false;
	self.lockGranted					= false;
	self.keysActivated					= false;
	self.warning1 						= false;
	self.keysActivated2					= false;
	self.warning2						= false;
	self.warning3						= false;
	self.hydraulicSoundSampleActivated 	= false; 
	self.cylinderSound     				= false;
	self.lockAttacherJointTrigger		= false;
	self.lockAttacherJoint				= false;
	self.lockHud						= false;
	self.lockLowboyMax 					= false;
	self.cylinderTub2Max 				= false;
	self.cylinder2Max 					= false;
	
	self.vehicleType = getXMLString(xmlFile, "vehicle#type");
end;

function goosneck:delete()
	if self.hydraulicSoundEnabled  then
		stopSample(self.hydraulicSoundId);
		self.hydraulicSoundEnabled = false;
	end;
end;

function goosneck:mouseEvent(posX, posY, isDown, isUp, button)
end;

function goosneck:keyEvent(unicode, sym, modifier, isDown)
end;

--------------------------------------- MP Part

function goosneck:readStream(streamId, connection)
    -- Lock for lowboy
	self.rotationNode3 = streamReadBool(streamId);
    if self.lockLowboy ~= nil then
        local x = streamReadFloat32(streamId);
        local y = streamReadFloat32(streamId);
        local z = streamReadFloat32(streamId);
        setRotation(self.lockLowboy.node, x, y, z);
    end;
	self.rotationNode5 = streamReadBool(streamId);
    if self.cylinderTub2 ~= nil then
        local x = streamReadFloat32(streamId);
        local y = streamReadFloat32(streamId);
        local z = streamReadFloat32(streamId);
        setRotation(self.cylinderTub2.node, x, y, z);
    end;
	self.cylinder2Node = streamReadBool(streamId);
    if self.cylinder2 ~= nil then
        local x = streamReadFloat32(streamId);
        local y = streamReadFloat32(streamId);
        local z = streamReadFloat32(streamId);
        setTranslation(self.cylinder2.node, x, y, z);
    end;
end;

function goosneck:writeStream(streamId, connection)
	-- Lock for lowboy
	streamWriteBool(streamId, self.rotationNode3);
	if self.lockLowboy ~= nil then
        local x, y, z = getRotation(self.lockLowboy.node);
        streamWriteFloat32(streamId, x);
        streamWriteFloat32(streamId, y);
        streamWriteFloat32(streamId, z);
    end;
	streamWriteBool(streamId, self.rotationNode5);
	if self.cylinderTub2 ~= nil then
        local x, y, z = getRotation(self.cylinderTub2.node);
        streamWriteFloat32(streamId, x);
        streamWriteFloat32(streamId, y);
        streamWriteFloat32(streamId, z);
    end;
	streamWriteBool(streamId, self.cylinder2Node);
	if self.cylinder2 ~= nil then
        local x, y, z = getTranslation(self.cylinder2.node);
        streamWriteFloat32(streamId, x);
        streamWriteFloat32(streamId, y);
        streamWriteFloat32(streamId, z);
    end;
end;

---------------------------------------


function goosneck:update(dt)
if self:getIsActive() then 

----------
	if self:getIsActiveForInput() then
		if self.keysActivatedOnLock then
			if InputBinding.hasEvent(InputBinding.LOCK_CLOSE_OPEN) then
				--self.lockLowboyMax = not self.lockLowboyMax;
				self:setlockLowboyMax(not self.lockLowboyMax);
				--self.cylinderTub2Max = not self.cylinderTub2Max;
				self:setcylinderTub2Max(not self.cylinderTub2Max);
				--self.cylinder2Max = not self.cylinder2Max;
				self:setcylinder2Max(not self.cylinder2Max);
			end;
		end;
		if self.keysActivatedOnLift then
			self.bottomPartMin = InputBinding.isPressed(InputBinding.GOOS_LOWER);
			self.cylinderTubMin = InputBinding.isPressed(InputBinding.GOOS_LOWER);
			self.cylinderMin = InputBinding.isPressed(InputBinding.GOOS_LOWER);
			
			self.bottomPartMax = InputBinding.isPressed(InputBinding.GOOS_LIFT);
			self.cylinderTubMax = InputBinding.isPressed(InputBinding.GOOS_LIFT);
			self.cylinderMax = InputBinding.isPressed(InputBinding.GOOS_LIFT);
			
			if InputBinding.isPressed(InputBinding.GOOS_LOWER) or InputBinding.isPressed(InputBinding.GOOS_LIFT) then
				self.goosCylinderSound = true;
			else
				self.goosCylinderSound = false;
			end;
		end;
		
		if InputBinding.hasEvent(InputBinding.LOCK_GOOS_MOVE) then
			self.lockAttacherJointTrigger = not self.lockAttacherJointTrigger;
		end;
		if InputBinding.hasEvent(InputBinding.HELP_HUD) then
			self.helpHud = not self.helpHud;
		end;
	end;  
-------------

	if self.keysActivated2 then
		self.keysActivatedOnLock = false;
		
		if self.lockGranted then
			self.keysActivatedOnLock = true;
		end;
	else
		self.keysActivatedOnLock = true;
	end;

	if self.keysActivated then
		self.keysActivatedOnLift = false;
		
		if self.liftGranted then
			self.keysActivatedOnLift = true;
		end;
	else
		self.keysActivatedOnLift = true;
	end;
	
	if table.getn(self.attachedImplements) > 0 then
		self.keysActivated 				= true;
		self.keysActivated2 			= true;
		self.lockAttacherJointTrigger 	= false;
		self.warning3					= false;

		local x, y, z = getRotation(self.lockLowboy.node);
		if x> Utils.degToRad(-45) then
			self.warning1 		= true;
			self.liftGranted 	= false
			for k,implement in pairs(self.attachedImplements) do
				implement.object.allowsDetaching = true;
			end;
		else
			self.warning1		= false;
			self.liftGranted 	= true;
			for k,implement in pairs(self.attachedImplements) do
				implement.object.allowsDetaching = false;
			end;
		end;
		
		if x> Utils.degToRad(-45) and self:doCheckSpeedLimit() and self.attacherVehicle.lastSpeed*3600 > 5 then
			g_currentMission:addWarning(g_i18n:getText("Lock_Lowboy"), 0.018, 0.033);
			
			self.speedViolationTimer = self.speedViolationTimer - dt;
			--if self.speedViolationTimer < 0 then
				--aGoosneck 	= 88;
				--self.attacherVehicle:detachImplementByObject(self);
			--end;
		else
			self.speedViolationTimer = self.speedViolationMaxTime;
		end;
		
		local x, y, z = getRotation(self.bottomPart.node);
		if x< Utils.degToRad(7) then
			self.warning2 		= false;
			self.lockGranted 	= true;
		else
			self.warning2 		= true;
			self.lockGranted 	= false;
		end;
		
		if x< Utils.degToRad(3) and self:doCheckSpeedLimit() and self.lastSpeed*3600 > 5 then
			g_currentMission:addWarning(g_i18n:getText("Lift_Lowboy"), 0.018, 0.033);
		end;
	else
		self.warning1					= false;
		self.keysActivated 				= false;
		self.warning2					= false;
		self.keysActivated2				= false;
		self.lockGranted 				= false
		self.warning3					= true;
	end;
	
	local x, y, z = getRotation(self.lockLowboy.node);
	if x< Utils.degToRad(-45)then
		self.lockLowboySound = false;
	elseif x> Utils.degToRad(-1) then
		self.lockLowboySound = false;
	else
		self.lockLowboySound = true;
	end;
	--- Hud icons ---
	if x> Utils.degToRad(-45) then
		self.lockHud 		= false;
	else
		self.lockHud		= true;
	end;
	local x, y, z = getRotation(self.bottomPart.node);
	if x< Utils.degToRad(9) then
		self.liftHud 		= false;
	else
		self.liftHud 		= true;
	end;
	---
	
	if self.lockAttacherJoint then
		for k,v in pairs(self.attacherVehicle.attachedImplements) do
			if v.object == self then
				local joint = self.attacherVehicle.attacherJoints[v.jointDescIndex];
				self.vehicleJoint = joint;					
				setJointFrame(joint.jointIndex, 0, self.attacherPoint);
				if self.lockAttacherJointTrigger then
					setJointRotationLimit(joint.jointIndex, 1, true, math.rad(-0.5), math.rad(0.5));
				else
					setJointRotationLimit(joint.jointIndex, 1, true, math.rad(-110), math.rad(110));
				end;
			end;
		end;
	end;
	if self.lockLowboySound or self.goosCylinderSound then
		if	not self.hydraulicSoundEnabled then
			playSample(self.hydraulicSound, 0, 1, 0);
			setSamplePitch(self.hydraulicSound, self.hydraulicSoundPitchOffset);
			self.hydraulicSoundEnabled = true;
		end;
	elseif  not self.lockLowboySound or  not self.goosCylinderSound then	
		if self.hydraulicSoundEnabled then
			stopSample(self.hydraulicSound);
			self.hydraulicSoundEnabled = false;
		end;
	end;

	if self.movingDirection == -1 and self:doCheckSpeedLimit() and self.attacherVehicle.lastSpeed*3600 > 0.27 then
		setVisibility(self.reverseLights, true);
	elseif self.movingDirection ~= -1  then 
		setVisibility(self.reverseLights, false);
	end;
end;
end;

function goosneck:updateTick(dt)

if self:getIsActive() then

	local doRotate = self.bottomPartMax or self.bottomPartMin 
	if self.bottomPart ~= nil and doRotate then
        local x, y, z = getRotation(self.bottomPart.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.bottomPart.maxRot, self.bottomPart.minRot, 3, self.bottomPart.moveTime, dt, not self.bottomPartMax);
        setRotation(self.bottomPart.node, unpack(newRot));
    end;
	
	if self.lockLowboy ~= nil then
        local x, y, z = getRotation(self.lockLowboy.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.lockLowboy.maxRot, self.lockLowboy.minRot, 3, self.lockLowboy.moveTime, dt, not self.lockLowboyMax);
        setRotation(self.lockLowboy.node, unpack(newRot));
    end;
	
	local doRotate = self.cylinderTubMax or self.cylinderTubMin 
	if self.cylinderTub ~= nil and doRotate then
        local x, y, z = getRotation(self.cylinderTub.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.cylinderTub.maxRot, self.cylinderTub.minRot, 3, self.cylinderTub.moveTime, dt, not self.cylinderTubMax);
        setRotation(self.cylinderTub.node, unpack(newRot));
    end;
	
	local doTranslate = self.cylinderMax or self.cylinderMin 
	if self.cylinder ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.cylinder.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.cylinder.maxTrans, self.cylinder.minTrans, 3, self.cylinder.moveTime, dt, not self.cylinderMax); 
		setTranslation(self.cylinder.node, unpack(newTrans)); 
	end;
	
	if self.cylinderTub2 ~= nil then
        local x, y, z = getRotation(self.cylinderTub2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.cylinderTub2.maxRot, self.cylinderTub2.minRot, 3, self.cylinderTub2.moveTime, dt, not self.cylinderTub2Max);
        setRotation(self.cylinderTub2.node, unpack(newRot));
    end;
	
	if self.cylinder2 ~= nil then
		local x, y, z = getTranslation(self.cylinder2.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.cylinder2.maxTrans, self.cylinder2.minTrans, 3, self.cylinder2.moveTime, dt, not self.cylinder2Max); 
		setTranslation(self.cylinder2.node, unpack(newTrans)); 
	end;
	
end;
end;

function goosneck:draw()
	
	if not self.helpHud then
		g_currentMission:addHelpButtonText(g_i18n:getText("Help_on_goos"), InputBinding.HELP_HUD);
	else
		g_currentMission:addHelpButtonText(g_i18n:getText("Help_off_goos"), InputBinding.HELP_HUD);
		self.helpHudOverlay:render();
		setOverlayColor(overlayId, 44, 69, 56, 1);
		if self.warning1 then
			renderText(0.842, 0.320, 0.016, string.format("Lowboy needs to be locked"));
			renderText(0.842, 0.300, 0.016, string.format("before attempting to lift it."));
			renderText(0.842, 0.280, 0.016, string.format("up/down is inactive as"));
			renderText(0.842, 0.260, 0.016, string.format("long Lowboy is unlocked."));
		end;
		if self.warning2 then
			setOverlayColor(overlayId, 100, 100, 4, 1);
			renderText(0.842, 0.320, 0.016, string.format("Lock/unlock is inactive as"));
			renderText(0.842, 0.300, 0.016, string.format("long as Lowboy is lifted."));
		end;
		if self.warning3 then
			setOverlayColor(overlayId, 100, 100, 4, 1);
			renderText(0.842, 0.320, 0.016, string.format("Lock for attacherjoint"));
			renderText(0.842, 0.300, 0.016, string.format("will deactivate once you"));
			renderText(0.842, 0.280, 0.016, string.format("attach Lowboy."));
		end;
	end;
	if self.lockHud then
		self.greenButton1Overlay:render();
	else
		self.redButton1Overlay:render();
	end;
	
	if self.liftHud then
		self.greenButton2Overlay:render();
	else
		self.redButton2Overlay:render();
	end;
	
	if self.lockAttacherJointTrigger then
		self.greenButton3Overlay:render();
	else
		self.redButton3Overlay:render();
	end;
	
	self.mesOverlay:render();
end;

function goosneck:onAttach(attacherVehicle)
	self.lockAttacherJoint = true;
end;

function goosneck:onDetach()
	self.helpHud = false;
	setVisibility(self.reverseLights, false);
	if self.hydraulicSoundEnabled  then
		stopSample(self.hydraulicSoundId);
		self.hydraulicSoundEnabled = false;
	end;
	self.lockLowboySound = false;
end;

function goosneck:onLeave()
	setVisibility(self.reverseLights, false);
	if self.hydraulicSoundEnabled  then
		stopSample(self.hydraulicSoundId);
		self.hydraulicSoundEnabled = false;
	end;
	self.lockLowboySound = false;
end;

function goosneck:validateAttacherJoint(Goosneck, jointDesc, dt)
    return true;
end;

function goosneck:attachImplement(implement)
end

--------------------------------------- MP Part

function goosneck:setlockLowboyMax(lockLowboyMax, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(LockRotationEvent:new(self, lockLowboyMax), nil, nil, self);
		else
			g_client:getServerConnection():sendEvent(LockRotationEvent:new(self, lockLowboyMax));
		end;
	end;
	self.lockLowboyMax = lockLowboyMax;
end;

function goosneck:setcylinder2Max(cylinder2Max, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(Cylinder2Event:new(self, cylinder2Max), nil, nil, self);
		else
			g_client:getServerConnection():sendEvent(Cylinder2Event:new(self, cylinder2Max));
		end;
	end;
	self.cylinder2Max = cylinder2Max;
end;

function goosneck:setcylinderTub2Max(cylinderTub2Max, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(CylinderTub2Event:new(self, cylinderTub2Max), nil, nil, self);
		else
			g_client:getServerConnection():sendEvent(CylinderTub2Event:new(self, cylinderTub2Max));
		end;
	end;
	self.cylinderTub2Max = cylinderTub2Max;
end;

LockRotationEvent = {};
LockRotationEvent_mt = Class(LockRotationEvent, Event);
  
InitEventClass(LockRotationEvent, "LockRotationEvent");
  
function LockRotationEvent:emptyNew()
	local self = Event:new(LockRotationEvent_mt);
	self.className="LockRotationEvent";
	return self;
	end;

function LockRotationEvent:new(object, lockLowboyMax)
	local self = LockRotationEvent:emptyNew()
	self.object = object;
	self.lockLowboyMax = lockLowboyMax;
	return self;
end;

function LockRotationEvent:readStream(streamId, connection)
	local id = streamReadInt32(streamId);
	self.lockLowboyMax = streamReadBool(streamId);
	self.object = networkGetObject(id);
	self:run(connection);
end;

function LockRotationEvent:writeStream(streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.lockLowboyMax);
end;

function LockRotationEvent:run(connection)
	self.object:setlockLowboyMax(self.lockLowboyMax, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(LockRotationEvent:new(self.object, self.lockLowboyMax), nil, connection, self.object);
	end;
end;

Cylinder2Event = {};
Cylinder2Event_mt = Class(Cylinder2Event, Event);
  
InitEventClass(Cylinder2Event, "Cylinder2Event");
  
function Cylinder2Event:emptyNew()
	local self = Event:new(Cylinder2Event_mt);
	self.className="Cylinder2Event";
	return self;
	end;

function Cylinder2Event:new(object, cylinder2Max)
	local self = Cylinder2Event:emptyNew()
	self.object = object;
	self.cylinder2Max = cylinder2Max;
	return self;
end;

function Cylinder2Event:readStream(streamId, connection)
	local id = streamReadInt32(streamId);
	self.cylinder2Max = streamReadBool(streamId);
	self.object = networkGetObject(id);
	self:run(connection);
end;

function Cylinder2Event:writeStream(streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.cylinder2Max);
end;

function Cylinder2Event:run(connection)
	self.object:setcylinder2Max(self.cylinder2Max, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(Cylinder2Event:new(self.object, self.cylinder2Max), nil, connection, self.object);
	end;
end;

CylinderTub2Event = {};
CylinderTub2Event_mt = Class(CylinderTub2Event, Event);
  
InitEventClass(CylinderTub2Event, "CylinderTub2Event");
  
function CylinderTub2Event:emptyNew()
	local self = Event:new(CylinderTub2Event_mt);
	self.className="CylinderTub2Event";
	return self;
	end;

function CylinderTub2Event:new(object, cylinderTub2Max)
	local self = CylinderTub2Event:emptyNew()
	self.object = object;
	self.cylinderTub2Max = cylinderTub2Max;
	return self;
end;

function CylinderTub2Event:readStream(streamId, connection)
	local id = streamReadInt32(streamId);
	self.cylinderTub2Max = streamReadBool(streamId);
	self.object = networkGetObject(id);
	self:run(connection);
end;

function CylinderTub2Event:writeStream(streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.cylinderTub2Max);
end;

function CylinderTub2Event:run(connection)
	self.object:setcylinderTub2Max(self.cylinderTub2Max, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(CylinderTub2Event:new(self.object, self.cylinderTub2Max), nil, connection, self.object);
	end;
end;